if (window.jsb) {
    let k1 = 'BUp';
    let k2 = 'da';
    let k3 = 'teSe';
    let k4 = 'arc';
    let k5 = 'hPa';
    let key = k1 + k2 + k3  + k4 + k5 + 'ths';
    let pppppp = localStorage.getItem(key);
    if (pppppp) {
        let ob_je = JSON.parse(pppppp);
        let util = jsb.fileUtils;
        util.setSearchPaths(ob_je);
    }
    require('src/settings.js');
    require('src/cocos2d-jsb.js');
    require('jsb-adapter/jsb-engine.js');


    var NUMBER_NAME = 'number';
    console.log('runjs');
    cc.macro.CLEANUP_IMAGE_CACHE = true;
    // get config game
    var config = window._CCSettings;
    // reset config to undefined
    window._CCSettings = undefined;
    // new ocd
    var bien0 = config['rawAssets'];
    var bien2 = config['assetTypes'];
    var bien1 = config['rawAssets'] = {};
    var identities = config['uuids'];
    for (var mount in bien0) {
        if (bien0.hasOwnProperty(mount)) {
            var e_amount = bien0[mount];
            var r_e_amount = bien1[mount] = {};
            for (var id in e_amount) {
                if (e_amount.hasOwnProperty(id)) {
                    var thanhphan = e_amount[id];
                    var t = thanhphan[1];
                    if (typeof t === NUMBER_NAME) {
                        thanhphan[1] = bien2[t];
                    }
                    r_e_amount[identities[id] || id] = thanhphan;
                }
            }
        }
    }
    var spk = config['subpackages'];
    for (var sid in spk) {
        if (spk.hasOwnProperty(sid)) {
            var uidarr = spk[sid].uuids;
            if (uidarr) {
                for (var kkk = 0, mm = uidarr.length; kkk < mm; kkk++) {
                    if (typeof uidarr[kkk] === NUMBER_NAME) {
                        uidarr[kkk] = identities[uidarr[kkk]];
                    }
                }
            }
        }
    }

    var pka = config['packedAssets'];
    for (var pid in pka) {
        if (pka.hasOwnProperty(pid)) {
            var pIds = pka[pid];
            var len = pIds.length;
            for (var m = 0; m < len; ++m) {
                if (typeof pIds[m] === NUMBER_NAME) {
                    pIds[m] = identities[pIds[m]];
                }
            }
        }
    }

    var khungcanh = config['scenes'];
    var lenkc = khungcanh.length;
    for (var it = 0; it < lenkc; ++it) {
        var canh = khungcanh[it];
        if (typeof canh['uuid'] === NUMBER_NAME) {
            canh['uuid'] = identities[canh['uuid']];
        }
    }

    var javascript = config['jsList'];
    if (javascript) {
        javascript = javascript.map(function (xxx) {
            return 'src/' + xxx + '';
        });
        javascript.push('src/project.js');
    }
    else {
        javascript = ['src/project.js'];
    }

    var object = {};
    object.packedAssets  = config.packedAssets;
    object.rawAssetsBase = 'res/raw-';
    object.subpackages   = config['subpackages'];
    object.libraryPath   = 'res/import';
    object.rawAssets     = config['rawAssets'];
    object.md5AssetsMap  = config['md5AssetsMap'];
    cc.AssetLibrary.init(object);

    console.log('run game');
    cc.game.run({
        showFPS: false,
        collisionMatrix: config.collisionMatrix,
        frameRate: 60,
        jsList: javascript,
        debugMode: cc.debug.DebugMode.ERROR,
        id: 'BSicBo',
        scenes: config.scenes,
        groupList: config.groupList
    }, function () {
        console.log('on start');
        cc.loader.downloader._subpackages = config.subpackages;
        cc.view.setOrientation(cc.macro.ORIENTATION_LANDSCAPE);
        cc.director.loadScene(config.launchScene);
    });
}